package ru.landgrafhomyak.db.skeleton1.api.module

import ru.landgrafhomyak.db.skeleton1.api.LowLevelApi
import ru.landgrafhomyak.db.skeleton1.api.statement.RawStatement
import ru.landgrafhomyak.db.skeleton1.api.statement._Statement
import ru.landgrafhomyak.db.skeleton1.api.runtime.InputRow
import ru.landgrafhomyak.db.skeleton1.api.table.Table


public interface ModuleUpgradeScope<nmUE : Any, omUE : Any> : ModuleConstructorScope<nmUE> {
	// Table -------------------------------------------------------------------
	public fun <tUE : Any> table_keep(table: Table<tUE, omUE>): Table<tUE, nmUE>
	public fun <tUE : Any> table_keepAndMove(
		table: Table<tUE, omUE>,
		newLocation: NameNode<nmUE>
	): Table<tUE, nmUE>

	public fun <ntUE : Any, otUE : Any> table_upgrade(
		oldTable: Table<otUE, omUE>,
		upgrade: Table.Upgrade<ntUE, otUE>
	): Table<ntUE, nmUE>

	public fun <ntUE : Any, otUE : Any> table_upgradeAndMove(
		table: Table<otUE, omUE>,
		newLocation: NameNode<nmUE>,
		upgrade: Table.Upgrade<ntUE, otUE>
	): Table<ntUE, nmUE>

	public fun table_delete(table: Table<*, omUE>)
	public fun <tUE : Any> table_deleteAfterModuleUpgrade(table: Table<tUE, omUE>): Table<tUE, nmUE>

	public fun table_export(table: Table<*, omUE>)
	public fun <tUE : Any> table_import(table: Table<tUE, *>, location: NameNode<nmUE>): Table<tUE, nmUE>

	public fun <ntUE : Any, otUE : Any> table_importAndUpgrade(
		table: Table<otUE, *>,
		location: NameNode<nmUE>,
		upgrade: Table.Upgrade<ntUE, otUE>
	): Table<ntUE, nmUE>

	// Object ------------------------------------------------------------------

	public fun object_keep(obj: ModuleScopedObject<omUE>): ModuleScopedObject<nmUE>
	public fun object_keepAndMove(
		obj: ModuleScopedObject<omUE>,
		newLocation: NameNode<nmUE>,
	): ModuleScopedObject<nmUE>

	public fun object_delete(obj: ModuleScopedObject<omUE>)
	public fun object_deleteAfterModuleUpgrade(obj: ModuleScopedObject<omUE>): ModuleScopedObject<nmUE>

	public fun object_export(obj: ModuleScopedObject<omUE>)
	public fun object_import(
		obj: ModuleScopedObject<*>,
		location: NameNode<nmUE>
	): ModuleScopedObject<nmUE>


	// Module ------------------------------------------------------------------

	public fun <smUE : Any> submodule_keep(module: Module<smUE>): Module<smUE>
	public fun <smUE : Any> submodule_keepAndMove(oldModule: Module<smUE>, newNs: NameNode<nmUE>): Module<smUE>

	public fun <smUE : Any> submodule_upgrade(oldModule: Module<*>, template: Module.Template<smUE>): Module<smUE>
	public fun <smUE : Any> submodule_upgradeAndMove(
		oldModule: Module<*>,
		newNamespace: NameNode<nmUE>,
		template: Module.Template<smUE>
	): Module<smUE>

	public fun submodule_delete(oldModule: Module<*>)
	public fun <smUE : Any> submodule_deleteAfterModuleUpgrade(oldModule: Module<smUE>): Module<smUE>

	public fun submodule_export(table: Module<*>)

	public fun <smUE : Any> submodule_import(
		module: Module<smUE>,
		location: NameNode<nmUE>,
	): Module<smUE>

	public fun <nsmUE : Any, osmUE : Any> submodule_importAndUpgrade(
		module: Module<osmUE>,
		location: NameNode<nmUE>,
		upgrade: Module.Upgrade<nsmUE, osmUE>
	): Module<nsmUE>

	// Statements --------------------------------------------------------------

	public fun addStatementAfterUpgrade(stmt: _Statement.Void2Void<*>)
	public fun addStatementAfterUpgrade(stmt: RawStatement.Void2Void.ImplementationsProvider<*>)

	@LowLevelApi
	public fun <sUE : Any> _addStatementAfterUpgrade(stmt: _Statement.Params2Void<sUE>): InputRow._Scope<sUE, Unit>

	@LowLevelApi
	public fun <sUE : Any> _addStatementAfterUpgrade(stmt: RawStatement.Params2Void.ImplementationsProvider<sUE>): InputRow._Scope<sUE, Unit>
}